package ast;

import java.util.List;

import types.Type;

public class Id extends Node implements Exp {
	public String name;
	public Type type;
	
	public Id(String name, int line, int col) {
		super(line, col);
		this.name = name;
	}
	
	public String label() {
		return name;
	}
	
	public Object eval(Environment<Object> env) {
		return env.lookup(name);
	}

	@Override
	public Type tcExp(Environment<Type> tenv) {
		return tenv.lookup(name);
	}

	@Override
	public Exp ccExp(Environment<LocId> env, PrimFunc cur,
			List<PrimFunc> funcs) {
		LocId loc = env.lookup(name);
		if(loc.owner != cur) {
			loc.shared = true;
			while(cur != loc.owner){
				cur.env.add(loc.id);
				cur = cur.parent;
			}
		}
		return this;
	}
	
	@Override
	public String toString() {
		return name;
	}

}
